#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>
#include <sys/stat.h>

void usage( void );
bool process_command_line( int argc, char *argv[] );

int gobjects;

char folder[30];
int main( int argc, char *argv[] )

{
  gobjects = -1;

  if ( argc == 1 || ( argc == 2 && *++argv[0] == '?' ) ) {
    usage();
    exit( 1 );
  }
  if ( !process_command_line( argc, argv ) ) {
    usage();
    exit( 1 );
  }

  char filename[50];
  char separator[2] = "\0";
  if(folder[0]) {
    mkdir(folder, S_IRWXU);
    separator[0] = '/';
  }
  sprintf(filename, "%s%sp%d.hddl", folder, separator, gobjects);
  FILE *file = fopen(filename, "w");
  int i;

  fprintf(file, "(define (problem tireworld-%d)", gobjects);
  fprintf(file, "\n(:domain tyreworld)");

  fprintf(file, "\n(:objects ");
  fprintf(file, "\n\twrench jack pump - tool");
  fprintf(file, "\n");
  for ( i = 0; i < gobjects; i++ ) {
    fprintf(file, "\tthe-hub%d ", i+1);
  }
  fprintf(file, "\n\t- hub");
  fprintf(file, "\n\t");
  for ( i = 0; i < gobjects; i++ ) {
    fprintf(file, "nuts%d ", i+1);
  }
  fprintf(file, "\n\t- nut");
  fprintf(file, "\n");
  fprintf(file, "\n\tboot - container");
  fprintf(file, "\n\t");
  for ( i = 0; i < gobjects; i++ ) {
    fprintf(file, "r%d w%d ", i+1, i+1);
  }
  fprintf(file, "\n\t- wheel");
  fprintf(file, "\n)\n");

  fprintf(file, "(:htn\n");
  fprintf(file, "\t:parameters ()\n");
  fprintf(file, "\t:subtasks (and\n");
  fprintf(file, "\t\t(Init)\n");
  fprintf(file, "\t)\n)");
	
	
 
  fprintf(file, "\n(:init");
  fprintf(file, "\n\t(in jack boot)"); 
  fprintf(file, "\n\t(in pump boot)"); 
  fprintf(file, "\n\t(in wrench boot)");
  fprintf(file, "\n\t(unlocked boot)");
  fprintf(file, "\n\t(closed boot)");
  for ( i = 0; i < gobjects; i++ ) {
    fprintf(file, "\n\t(intact r%d)", i+1); 
    fprintf(file, "\n\t(in r%d boot)", i+1); 
    fprintf(file, "\n\t(not-inflated r%d)", i+1);
  } 
  for ( i = 0; i < gobjects; i++ ) {
    fprintf(file, "\n\t(on w%d the-hub%d)", i+1, i+1); 
    fprintf(file, "\n\t(old w%d)", i+1); 
    fprintf(file, "\n\t(on-ground the-hub%d)", i+1); 
    fprintf(file, "\n\t(tight nuts%d the-hub%d)", i+1, i+1);
    fprintf(file, "\n\t(fastened the-hub%d)", i+1);
  }
  fprintf(file, "\n))\n");

  fclose(file);
  exit( 0 );

}

void usage( void )

{

  printf("\nusage:\n");

  printf("\nOPTIONS   DESCRIPTIONS\n\n");
  printf("-n <num>    number of tyres (minimal 1)\n\n");

}



bool process_command_line( int argc, char *argv[] )

{

  char option;

  while ( --argc && ++argv ) {
    if ( *argv[0] != '-' || strlen(*argv) != 2 ) {
      return false;
    }
    option = *++argv[0];
    switch ( option ) {
    default:
      if ( --argc && ++argv ) {
	switch ( option ) {
	case 'n':
	  sscanf( *argv, "%d", &gobjects );
	  break;
  case 'f':
    sscanf(*argv, "%s", folder);
    break;
	default:
	  printf( "\n\nunknown option: %c entered\n\n", option );
	  return false;
	}
      } else {
	return false;
      }
    }
  }

  if ( gobjects < 1 ) {
    return false;
  }

  return true;

}
